//
//  UIImage+SA.m
//  Quartz2D
//
//  Created by 余西安 on 14/12/1.
//  Copyright (c) 2014年 Sian. All rights reserved.
//

#import "UIImage+SA.h"

@implementation UIImage (SA)

+ (instancetype)roundCutImage:(NSString *)imageName edgeWidth:(float)width
{
    // 0、新图片的大小为原有图片基本上加外边框宽度
    UIImage *image = [UIImage imageNamed:imageName];
    CGSize newSize = CGSizeMake(image.size.width + width * 2, image.size.height + width * 2);
    
    // 1、开启位图上下文
    UIGraphicsBeginImageContextWithOptions(newSize, NO, 0.0);
    
    // 2、获取位图上下文
    CGContextRef c = UIGraphicsGetCurrentContext();
    
    // 3、以新图片大小画底色为白色的圆
    CGContextAddEllipseInRect(c, (CGRect){CGPointZero, newSize});
    CGContextSetFillColorWithColor(c, [UIColor whiteColor].CGColor);
    CGContextFillPath(c);
    
    // 4、在图像上下文中描述一个原图大小的圆
    CGRect imageRect = (CGRect){width, width, image.size};
    CGContextAddEllipseInRect(c, imageRect);
    
    // 5、对描述进行裁剪，即其他区域不可渲染
    CGContextClip(c);
    
    // 6、将原图片渲染到上下文（被裁剪区域不可见）
    [image drawInRect:imageRect];
    
    // 7、获取上下文渲染出来的图片
    UIImage *newImage = UIGraphicsGetImageFromCurrentImageContext();
    
    // 8、关闭上下文描述
    UIGraphicsEndImageContext();
    
    return newImage;
}

@end
